com.fasterxml.jackson.dataformat.avro

## Class AvroMapper

- java.lang.Object
- - com.fasterxml.jackson.core.TreeCodec
  - - com.fasterxml.jackson.core.ObjectCodec
    - - com.fasterxml.jackson.databind.ObjectMapper
      - - com.fasterxml.jackson.dataformat.avro.AvroMapper

- All Implemented Interfaces:
    com.fasterxml.jackson.core.Versioned, Serializable

      public class AvroMapper
      extends com.fasterxml.jackson.databind.ObjectMapper

  Convenience `AvroMapper`, which is mostly similar to simply constructing a mapper with `AvroFactory`, but also adds little bit of convenience around `AvroSchema` generation.
  Since:
    2.5
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `AvroMapper.Builder` Base implementation for "Vanilla" `ObjectMapper`, used with Avro backend.

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.ObjectMapper

      `com.fasterxml.jackson.databind.ObjectMapper.DefaultTypeResolverBuilder, com.fasterxml.jackson.databind.ObjectMapper.DefaultTyping`

  - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.ObjectMapper

      `_configOverrides, _deserializationConfig, _deserializationContext, _injectableValues, _jsonFactory, _mixIns, _registeredModuleTypes, _rootDeserializers, _serializationConfig, _serializerFactory, _serializerProvider, _subtypeResolver, _typeFactory, DEFAULT_ANNOTATION_INTROSPECTOR, DEFAULT_BASE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `AvroMapper()` Constructor that will construct mapper with standard `AvroFactory` as codec, and will also register `AvroModule`.
    `` | `AvroMapper(AvroFactory f)` Constructor that will construct mapper with given `AvroFactory`, as well as register standard `AvroModule` (with default settings).
    `` | `AvroMapper(AvroFactory f, com.fasterxml.jackson.databind.Module... modules)` Constructor that will construct mapper with specified `AvroFactory` as codec, and register given modules but nothing else (that is, will only register `AvroModule` if it's included as argument.
    `` | `AvroMapper(com.fasterxml.jackson.databind.Module... modules)` Constructor that will construct mapper with standard `AvroFactory` as codec, and register given modules but nothing else (that is, will only register `AvroModule` if it's included as argument.
    `protected` | `AvroMapper(com.fasterxml.jackson.databind.ObjectMapper src)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static AvroMapper.Builder` | `builder()`
    `static AvroMapper.Builder` | `builder(AvroFactory streamFactory)`
    `AvroMapper` | `copy()`
    `AvroFactory` | `getFactory()`
    `AvroSchema` | `schemaFor(Class<?> type)` Factory method for constructing `AvroSchema` by introspecting given POJO type and building schema that contains specified properties.
    `AvroSchema` | `schemaFor(com.fasterxml.jackson.databind.JavaType type)` Factory method for constructing `AvroSchema` by introspecting given POJO type and building schema that contains specified properties.
    `AvroSchema` | `schemaFrom(File schemaFile)` Convenience method for reading `AvroSchema` from given encoded JSON representation.
    `AvroSchema` | `schemaFrom(InputStream in)` Method for reading an Avro Schema from given `InputStream`, and once done (successfully or not), closing the stream.
    `AvroSchema` | `schemaFrom(String schemaAsString)` Convenience method for reading `AvroSchema` from given encoded JSON representation.
    `com.fasterxml.jackson.core.Version` | `version()`
    `static AvroMapper.Builder` | `xmlBuilder()`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ObjectMapper

      `_assertNotNull, _checkInvalidCopy, _configAndWriteValue, _constructDefaultTypeResolverBuilder, _convert, _findRootDeserializer, _initForReading, _initForReading, _newReader, _newReader, _newWriter, _newWriter, _newWriter, _readMapAndClose, _readTreeAndClose, _readValue, _serializerProvider, _unwrapAndDeserialize, _verifyNoTrailingTokens, _verifySchemaType, acceptJsonFormatVisitor, acceptJsonFormatVisitor, activateDefaultTyping, activateDefaultTyping, activateDefaultTyping, activateDefaultTypingAsProperty, addHandler, addMixIn, addMixInAnnotations, canDeserialize, canDeserialize, canSerialize, canSerialize, clearProblemHandlers, configOverride, configure, configure, configure, configure, configure, constructType, convertValue, convertValue, convertValue, createArrayNode, createDeserializationContext, createObjectNode, deactivateDefaultTyping, defaultClassIntrospector, disable, disable, disable, disable, disable, disable, disable, disableDefaultTyping, enable, enable, enable, enable, enable, enable, enable, enableDefaultTyping, enableDefaultTyping, enableDefaultTyping, enableDefaultTypingAsProperty, findAndRegisterModules, findMixInClassFor, findModules, findModules, generateJsonSchema, getDateFormat, getDeserializationConfig, getDeserializationContext, getInjectableValues, getJsonFactory, getNodeFactory, getPolymorphicTypeValidator, getPropertyNamingStrategy, getRegisteredModuleIds, getSerializationConfig, getSerializerFactory, getSerializerProvider, getSerializerProviderInstance, getSubtypeResolver, getTypeFactory, getVisibilityChecker, isEnabled, isEnabled, isEnabled, isEnabled, isEnabled, isEnabled, isEnabled, isEnabled, missingNode, mixInCount, nullNode, reader, reader, reader, reader, reader, reader, reader, reader, reader, reader, reader, readerFor, readerFor, readerFor, readerForUpdating, readerWithView, readTree, readTree, readTree, readTree, readTree, readTree, readTree, readTree, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValues, readValues, readValues, readValues, registerModule, registerModules, registerModules, registerSubtypes, registerSubtypes, registerSubtypes, setAnnotationIntrospector, setAnnotationIntrospectors, setBase64Variant, setConfig, setConfig, setDateFormat, setDefaultLeniency, setDefaultMergeable, setDefaultPrettyPrinter, setDefaultPropertyInclusion, setDefaultPropertyInclusion, setDefaultSetterInfo, setDefaultTyping, setDefaultVisibility, setFilterProvider, setFilters, setHandlerInstantiator, setInjectableValues, setLocale, setMixInAnnotations, setMixInResolver, setMixIns, setNodeFactory, setPolymorphicTypeValidator, setPropertyInclusion, setPropertyNamingStrategy, setSerializationInclusion, setSerializerFactory, setSerializerProvider, setSubtypeResolver, setTimeZone, setTypeFactory, setVisibility, setVisibility, setVisibilityChecker, tokenStreamFactory, treeAsTokens, treeToValue, updateValue, valueToTree, writer, writer, writer, writer, writer, writer, writer, writer, writer, writer, writerFor, writerFor, writerFor, writerWithDefaultPrettyPrinter, writerWithType, writerWithType, writerWithType, writerWithView, writeTree, writeTree, writeValue, writeValue, writeValue, writeValue, writeValue, writeValueAsBytes, writeValueAsString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AvroMapper

          public AvroMapper()

      Constructor that will construct mapper with standard `AvroFactory` as codec, and will also register `AvroModule`.

    - #### AvroMapper

          public AvroMapper(AvroFactory f)

      Constructor that will construct mapper with given `AvroFactory`, as well as register standard `AvroModule` (with default settings).

    - #### AvroMapper

          public AvroMapper(com.fasterxml.jackson.databind.Module... modules)

      Constructor that will construct mapper with standard `AvroFactory` as codec, and register given modules but nothing else (that is, will only register `AvroModule` if it's included as argument.

    - #### AvroMapper

          public AvroMapper(AvroFactory f,
                            com.fasterxml.jackson.databind.Module... modules)

      Constructor that will construct mapper with specified `AvroFactory` as codec, and register given modules but nothing else (that is, will only register `AvroModule` if it's included as argument.

    - #### AvroMapper

          protected AvroMapper(com.fasterxml.jackson.databind.ObjectMapper src)

  - ### Method Detail

    - #### xmlBuilder

          public static AvroMapper.Builder xmlBuilder()

      Since:
        2.10

    - #### builder

          public static AvroMapper.Builder builder()

      Since:
        2.10

    - #### builder

          public static AvroMapper.Builder builder(AvroFactory streamFactory)

    - #### copy

          public AvroMapper copy()

      Overrides:
        `copy` in class `com.fasterxml.jackson.databind.ObjectMapper`

    - #### version

          public com.fasterxml.jackson.core.Version version()

      Specified by:
        `version` in interface `com.fasterxml.jackson.core.Versioned`
      Overrides:
        `version` in class `com.fasterxml.jackson.databind.ObjectMapper`

    - #### getFactory

          public AvroFactory getFactory()

      Overrides:
        `getFactory` in class `com.fasterxml.jackson.databind.ObjectMapper`

    - #### schemaFor

          public AvroSchema schemaFor(Class<?> type)
                               throws com.fasterxml.jackson.databind.JsonMappingException

      Factory method for constructing `AvroSchema` by introspecting given POJO type and building schema that contains specified properties.

      Resulting schema object does not use separate reader/writer schemas.

      Throws:
        `com.fasterxml.jackson.databind.JsonMappingException`
      Since:
        2.5

    - #### schemaFor

          public AvroSchema schemaFor(com.fasterxml.jackson.databind.JavaType type)
                               throws com.fasterxml.jackson.databind.JsonMappingException

      Factory method for constructing `AvroSchema` by introspecting given POJO type and building schema that contains specified properties.

      Resulting schema object does not use separate reader/writer schemas.

      Throws:
        `com.fasterxml.jackson.databind.JsonMappingException`
      Since:
        2.5

    - #### schemaFrom

          public AvroSchema schemaFrom(InputStream in)
                                throws IOException

      Method for reading an Avro Schema from given `InputStream`, and once done (successfully or not), closing the stream.

      Resulting schema object does not use separate reader/writer schemas.

      Throws:
        `IOException`
      Since:
        2.6

    - #### schemaFrom

          public AvroSchema schemaFrom(String schemaAsString)
                                throws IOException

      Convenience method for reading `AvroSchema` from given encoded JSON representation.

      Resulting schema object does not use separate reader/writer schemas.

      Throws:
        `IOException`
      Since:
        2.6

    - #### schemaFrom

          public AvroSchema schemaFrom(File schemaFile)
                                throws IOException

      Convenience method for reading `AvroSchema` from given encoded JSON representation.

      Resulting schema object does not use separate reader/writer schemas.

      Throws:
        `IOException`
      Since:
        2.6

Copyright © 2019 FasterXML. All rights reserved.